# Copyright ReportLab Europe Ltd. 2006
# $Id: travelplanapp.py 21155 2006-05-18 17:22:59Z cliff $
from rlextra.rml2pdf import rml2pdf
import os, string
from rlextra.ers import webapp
import travel
from rlextra.preppy import preppy
from rlextra.radxml.xmlutils import xml2doctree

class TravelPlanApp(webapp.WebApp):

    def __init__(self, **kw):
        self._setKeywords(**kw)
        webapp.WebApp.__init__(
            self,
            defaultAction='search',
            rsrcUrl='/rsrc/travelplan/',
            pageTemplate='travel_template.html'
            )
    def getRsrcUrl(self,name):
        return self.rsrcUrl+name
    def action_makepdf(self,request,response):
        params=request.params
        orig = params['orig']
        dest = params['dest']
        oDate = params['oDate']
        rDate = params['rDate']
        flightClass = params['flightClass']
        isRoundTrip = params['isRoundTrip']
        if isRoundTrip == 'True': isRT = True
        else: isRT = False
        presaleXML = travel.getPresaleXML(orig, dest,oDate,rDate,flightClass,isRT)        
        data=xml2doctree(presaleXML,0)
        module=preppy.getModule('template_presale.prep')
        rmlText=module.getOutput(dict(data=data))
        outfile='presale.pdf'
        pdf=rml2pdf.go(rmlText, outfile, outDir=self.OUTDIR)
        #pdfout=open(os.path.join(self.OUTDIR,outfile),'rb').read()
        #response.setHeader('Content-Disposition', 'inline; filename=%s' %outputFileName)
        #response.setContentType('application/pdf')
        #response.write(str(pdfout))
        location = os.path.join(self.HTTP_OUTDIR,outfile)
        params=request.params
        params['location']=location
        #L = []
        #a = L.append
        #a('<a href="travelplan.cgi">Start Over</a><br>')
        #a('The PdfLink option creates a PDF document from the data input and returns a link to the document.<br>')
        #a("<h1>Your PDF is ready...</h1>")
        #a("download PDF: <a href='%s'>%s</a>" % (location, outfile))
        #response.setHeader('Content-Disposition', 'inline; filename=%s' %outfile)
        #response.setContentType('text/html')
        #response.write(string.join(L,'\n'))
        self.runView(request,response,'download')

        
